Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  Block mit Attribut in eine Tabelle einfügen.

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   Block mit Attribut in eine Tabelle einfügen. (1405 mal gelesen)
CADlsp
Mitglied



Sehen Sie sich das Profil von CADlsp an!   Senden Sie eine Private Message an CADlsp  Schreiben Sie einen Gästebucheintrag für CADlsp

Beiträge: 10
Registriert: 04.02.2010

erstellt am: 25. Feb. 2010 14:58    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


Tabelle.zip

 
Hallo zusammen,

ein Block der Attribute in seiner Definition hat, erhält erst
bei der Einfügung die eigentlichen Attributsobjekte (0 . "ATTRIB").

Dies ermöglicht unterschiedlichste Texte mit einer Blockdefinition
auszudrücken.

Ich möchte die Zellen einer Spalte (siehe Tabelle.zip) mit jeweils einen Block
füllen, der ein Attribut hat (7 8 9 usw.)

Normale Blöcke einfügen wäre einfach:

(setq blk (vla-item (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object))) "Blockname"))
(setq id (vla-get-objectid blk))
(vla-SetBlockTableRecordId tabl row col id :VLAX-FALSE)
(vla-setcellalignment tabl row col acMiddleCenter)

Die variable blk ist aus der Blocktabelle generiert und hat demnach noch keine unterschiedlichen Attribute.

Vielen Dank und Grüße !

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 19657
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 25. Feb. 2010 22:25    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADlsp 10 Unities + Antwort hilfreich

Falls du möchtest das die Werte länger erhalten bleiben sollen: vergiss es.
Schau mal hier als Einstieg ->  KLICK! oder schau dir selbst die Datenstruktur
genauer an (Tabelle an sich und erst recht in Kombination mit "Blockreferenz in Tabelle")

------------------
CAD.de System-Angaben  -  CAD on demand  -  User:FAQ(Acad)

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADlsp
Mitglied



Sehen Sie sich das Profil von CADlsp an!   Senden Sie eine Private Message an CADlsp  Schreiben Sie einen Gästebucheintrag für CADlsp

Beiträge: 10
Registriert: 04.02.2010

erstellt am: 01. Mrz. 2010 08:14    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo,

noch eine ergänzende Frage. Vielleicht komme ich einfacher mit diesen
Methoden weiter:

(vla-GetBlockAttributeValue2 tabelle row col ncontent blkID)
(vla-SetBlockAttributeValue2 tabelle row col ncontent blkID value)
Beide Methoden haben im Moment keine Auswirkung auf meine Tabelle.

Die blkID hole ich über:
(setq blkID (vlax-invoke-method tabelle "GetBlockTableRecordId" 1 0))
Wie muss ncontent belegt sein? Wer hat Erfahrungen mit diesen Methoden?

Gruß!

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADlsp
Mitglied



Sehen Sie sich das Profil von CADlsp an!   Senden Sie eine Private Message an CADlsp  Schreiben Sie einen Gästebucheintrag für CADlsp

Beiträge: 10
Registriert: 04.02.2010

erstellt am: 03. Mrz. 2010 11:17    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo zusammen,

ich fand jetzt folgende Lösung. Ein kleiner Ausflug in die VBA Welt hat mir weitergeholfen.
Hier wird nach der Deklarierung der Tabelle (MyTable), die Methoden SetBlockAttributeValue
und GetBlockAttributeValue eindeutig vorgeschlagen.
Voraussetzung für mein Beispiel ist, dass die Blockdefinition existiert und nur ein Attribut hat.
Auch wird nur die Zelle 1 0 geändert. Aber dies geht natürlich mit jeder Blockzelle.

       

(defun c:beattab (/ vgbl vblk tabe attid nstr ostr)

  (vl-load-com)
  (setq vgbl (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object))))
  (setq vblk (vla-item vgbl "Blockname"))
  (vlax-for eblk vblk
    (if (= (vla-get-objectname eblk) "AcDbAttributeDefinition")
      (setq attid (vla-get-objectid eblk))
    )
  )

  (setq tabe (vlax-ename->vla-object (car (entsel "\nSelect table: "))))
  (setq nstr (getstring "\nNew attribut: "))

  (setq ostr (vla-getblockattributevalue tabe 1 0 attid))
  (vla-setblockattributevalue tabe 1 0 attid nstr)

)


; Oldstr = MyTable.GetBlockAttributeValue(1, 0, AttDef.ObjectID)
; MyTable.SetBlockAttributeValue 1, 0, AttDef.ObjectID, Newstr

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2020 CAD.de | Impressum | Datenschutz